package ca.canadapost.cpcdp.serviceinfo;

import java.io.FileInputStream;
import java.io.InputStream;
import java.util.Iterator;
import java.util.Properties;

import javax.xml.bind.JAXBContext;

import ca.canadapost.cpcdp.serviceinfo.generated.messages.Messages;
import ca.canadapost.cpcdp.serviceinfo.generated.serviceinfo.InfoMessage;
import ca.canadapost.cpcdp.serviceinfo.generated.serviceinfo.InfoMessages;

import com.sun.jersey.api.client.Client;
import com.sun.jersey.api.client.ClientResponse;
import com.sun.jersey.api.client.UniformInterfaceException;
import com.sun.jersey.api.client.WebResource;
import com.sun.jersey.api.client.config.ClientConfig;
import com.sun.jersey.api.client.config.DefaultClientConfig;

public class GetUaMailingServiceInfo {
	private Client aClient;
    private static String LINK;
    
    public static void main(String args[]){
    	Properties userProps = new Properties();
    	FileInputStream propInputStream;
		try {
			propInputStream = new FileInputStream("user.properties");
			userProps.load(propInputStream);
			propInputStream.close(); // better in finally block
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace(System.out);
			return;
		}
    	String username = userProps.getProperty("username");
    	String password = userProps.getProperty("password");

    	LINK = "https://ct.soa-gw.canadapost.ca/rs/serviceinfo/uamailing";
    	GetUaMailingServiceInfo myClient = new GetUaMailingServiceInfo(username, password);
    	ClientResponse resp = myClient.getServiceInfo();
        InputStream respIS = resp.getEntityInputStream();
        
        System.out.println("HTTP Response Status: " + resp.getStatus() + " " + resp.getClientResponseStatus());
        JAXBContext jc;
        try {
        	jc = JAXBContext.newInstance(InfoMessages.class,InfoMessage.class,Messages.class);
        	Object entity = jc.createUnmarshaller().unmarshal(respIS);
        	if(entity instanceof InfoMessages){
        		InfoMessages infoMessages = (InfoMessages) entity;
        		for(InfoMessage infoMessage : infoMessages.getInfoMessages()){
        			System.out.println("Message text :"+ infoMessage.getMessageText());
        			System.out.println("Message type :"+ infoMessage.getMessageType());
        			System.out.println("Message Start Date :"+ infoMessage.getFromDatetime());
        			System.out.println("Message End Date :"+ infoMessage.getToDatetime());
        		}
        	}
        	else {
        		// Assume Error Schema
        		Messages messageData = (Messages) entity;
        		for (Iterator<Messages.Message> iter = messageData.getMessage().iterator(); iter.hasNext();) {
        			Messages.Message aMessage = (Messages.Message) iter.next();
        			System.out.println("Error Code: " + aMessage.getCode());
        			System.out.println("Error Msg: " + aMessage.getDescription());
        		}
        	}
        } catch (Exception e) {
        	e.printStackTrace(System.out);
        }

        myClient.close();
    }
    
    public GetUaMailingServiceInfo(String username,String  password){
    	ClientConfig config = new DefaultClientConfig();
        aClient = Client.create(config);
        aClient.addFilter(new com.sun.jersey.api.client.filter.HTTPBasicAuthFilter(username, password));
    }
    public ClientResponse getServiceInfo() throws UniformInterfaceException {
        WebResource aWebResource = aClient.resource(LINK);
        return aWebResource.accept("application/vnd.cpc.serviceinfo-v2+xml").acceptLanguage("en-CA").get(ClientResponse.class);
    }
    public void close() {
        aClient.destroy();
    }
}
